// FullRemoteDisplaySDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FullRemoteDisplayS.h"
#include "FullRemoteDisplaySDlg.h"
#include ".\fullremotedisplaysdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WM_MSG_NOTIFY	WM_USER+0x373
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFullRemoteDisplaySDlg dialog



CFullRemoteDisplaySDlg::CFullRemoteDisplaySDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFullRemoteDisplaySDlg::IDD, pParent)
	, m_port(6333)
	, m_username(_T(""))
	, m_password(_T(""))
	, m_usedriver(FALSE)
	, bJpegOnly(TRUE)
{
	memset((void*)&nif,0,sizeof(nif));	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	lOldPort=0;
	nif.cbSize =sizeof(nif);
	nif.uID =6333;
	nif.uFlags =NIF_ICON|NIF_TIP|NIF_MESSAGE;
	nif.uCallbackMessage =WM_MSG_NOTIFY;
	strcpy(nif.szTip,"FullRemoteDisplayS");
	nif.hIcon =m_hIcon;
}

void CFullRemoteDisplaySDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDV_MinMaxLong(pDX, m_port, 1024, 65530);
	DDX_Text(pDX, IDC_USERNAME, m_username);
	DDV_MaxChars(pDX, m_username, 32);
	DDX_Text(pDX, IDC_PASSWORD, m_password);
	DDX_Check(pDX, IDC_USEDRIVER, m_usedriver);
	DDX_Check(pDX, IDC_JPG, bJpegOnly);
}

BEGIN_MESSAGE_MAP(CFullRemoteDisplaySDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_DESTROY()
	ON_MESSAGE(WM_MSG_NOTIFY,OnMsgProc)
END_MESSAGE_MAP()


// CFullRemoteDisplaySDlg message handlers

BOOL CFullRemoteDisplaySDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	IUnknown *pUnk;
	pUnk=GetDlgItem(IDC_RSERVER)->GetControlUnknown();
	pUnk->QueryInterface(&pServer);
	pServer->PutUseDriver(VARIANT_TRUE);
	pServer->put_ShowCursor(VARIANT_FALSE);
	pServer->put_CaptureBlt(VARIANT_TRUE);

	nif.hWnd =m_hWnd;
	Shell_NotifyIcon(NIM_ADD,&nif);


	m_username=AfxGetApp()->GetProfileString("FullRemoteS","UserName");
	m_password=AfxGetApp()->GetProfileString("FullRemoteS","Password");
	m_port=AfxGetApp()->GetProfileInt("FullRemoteS","Port",6333);
	m_usedriver=AfxGetApp()->GetProfileInt("FullRemoteS","UseDriver",1);
	bJpegOnly=AfxGetApp()->GetProfileInt("FullRemoteS","Jpeg",1);
	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

LRESULT CFullRemoteDisplaySDlg::OnMsgProc(WPARAM wParam,LPARAM lParam){
	if(GetKeyState(VK_LBUTTON)&0x8000){
		ShowWindow(SW_SHOW);
		SetForegroundWindow();
	}
	return 0;
}

void CFullRemoteDisplaySDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFullRemoteDisplaySDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFullRemoteDisplaySDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFullRemoteDisplaySDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	pServer->PutUserName((_bstr_t)m_username);
	pServer->PutPassword((_bstr_t)m_password);
	pServer->PutUseDriver(m_usedriver?VARIANT_TRUE:VARIANT_FALSE);
	if(bJpegOnly){
		pServer->PutCompressFrameToJpeg(VARIANT_TRUE);
	}else{
		pServer->PutCompressFrameToJpeg(VARIANT_FALSE);
	}
	if(lOldPort!=m_port){
		pServer->StopListening();
		if(pServer->StartListening(m_port)==VARIANT_FALSE){
			AfxMessageBox("Listening failed, Maybe the port was occuppied already");
		}else{
			lOldPort=m_port;
		}
	}
	if(pServer->InListeningMode==VARIANT_TRUE){
		AfxGetApp()->WriteProfileString("FullRemoteS","UserName",m_username);
		AfxGetApp()->WriteProfileString("FullRemoteS","Password",m_password);
		AfxGetApp()->WriteProfileInt("FullRemoteS","Port",m_port);
		AfxGetApp()->WriteProfileInt("FullRemoteS","UseDriver",m_usedriver);
		AfxGetApp()->WriteProfileInt("FullRemoteS","Jpeg",bJpegOnly);
		ShowWindow(SW_HIDE);
	}
}

void CFullRemoteDisplaySDlg::OnDestroy()
{
	if(pServer){
		pServer->Release();
	}
	Shell_NotifyIcon(NIM_DELETE,&nif);
	CDialog::OnDestroy();
	// TODO: ڴ˴Ϣ
}
BEGIN_EVENTSINK_MAP(CFullRemoteDisplaySDlg, CDialog)
	ON_EVENT(CFullRemoteDisplaySDlg, IDC_RSERVER, 1, OnConnectedRserver, VTS_I4)
END_EVENTSINK_MAP()

void CFullRemoteDisplaySDlg::OnConnectedRserver(long lClientID)
{
	// TODO: ڴ˴Ϣ
	IClient *pClient;
	pServer->raw_GetClient(lClientID,&pClient);
	pClient->put_Operable(VARIANT_TRUE);
	pClient->Release();
}
