// ChildView.cpp : CChildView ʵ
//

#include "stdafx.h"
#include "FullRemoteDisplayV.h"
#include "ChildView.h"
#include ".\childview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define STORE_FILE_NAME		L"storage_ipm"
#define STORE_FILE_NAME_A		"storage_ipm"
// CChildView

CChildView::CChildView()
{
	pCurrent=NULL;
	bDown=FALSE;
}

CChildView::~CChildView()
{
	m_storage.Save(STORE_FILE_NAME);
	m_small.DeleteImageList();
	m_large.DeleteImageList();
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_NEWDIRECTORY, OnNewdirectory)
	ON_COMMAND(ID_NEWHOST, OnNewhost)
	ON_COMMAND(ID_RENAME, OnRename)
	ON_COMMAND(ID_DELETE, OnDelete)
	ON_COMMAND(ID_ATTRIBUTES, OnAttributes)
	ON_COMMAND(ID_FULLCONTROL, OnFullcontrol)
	ON_COMMAND(ID_VIEWONLY, OnViewonly)
END_MESSAGE_MAP()



// CChildView Ϣ

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

#define TREE_ID				0x101
#define TREE_SECTION		"TREE_CTRL"
#define LIST_ID				0x102
#define LIST_SECTION		"LIST_CTRL"

#include <io.h>
int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// TODO:  ڴרõĴ
	m_tree_width=AfxGetApp()->GetProfileInt(TREE_SECTION,"tree_width",200);
	m_tree.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|TVS_HASLINES|TVS_HASBUTTONS|TVS_LINESATROOT|TVS_SHOWSELALWAYS|TVS_EDITLABELS,CRect(0,0,m_tree_width,0),this,TREE_ID);
	m_list.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|LVS_ICON|LVS_EDITLABELS|LVS_SHOWSELALWAYS|LVS_SINGLESEL,CRect(0,0,400,100),this,LIST_ID);

	m_large.Create(32,32,ILC_COLOR32|ILC_MASK,3,3);
	m_small.Create(16,15,ILC_COLOR32|ILC_MASK,3,3);
	CBitmap bmp;
	bmp.LoadBitmap(IDB_LARGE);
	m_large.Add(&bmp,RGB(255,255,255));
	bmp.DeleteObject();
	bmp.LoadBitmap(IDB_SMALL);
	m_small.Add(&bmp,RGB(255,255,255));
	bmp.DeleteObject();

	m_tree.SetImageList(&m_small,TVSIL_NORMAL);
	m_list.SetImageList(&m_small,LVSIL_SMALL);
	m_list.SetImageList(&m_large,LVSIL_NORMAL);
	if(_access(STORE_FILE_NAME_A,0)==-1){
		m_storage.InitializeForForstRun();
	}else{
		m_storage.Load(STORE_FILE_NAME);
	}
	InitializeDirectory();
	this->SetTreeList(&m_tree,&m_list);

	return 0;
}

void CChildView::OnSize(UINT nType, int cx, int cy)
{

	CWnd::OnSize(nType, cx, cy);
	// TODO: ڴ˴Ϣ
	Recalc();
}

void CChildView::Recalc(){
	RECT rcClient;
	GetClientRect(&rcClient);
	m_tree.MoveWindow(0,0,m_tree_width,rcClient.bottom );
	m_list.MoveWindow(m_tree_width+3,0,rcClient.right -m_tree_width,rcClient.bottom);
//	m_propbar.MoveWindow(rcClient.right -WIDTH_OF_PROPERTY_BAR,0,WIDTH_OF_PROPERTY_BAR,rcClient.bottom);
}

void CChildView::InitializeDirectory(){
	PSTORAGE_INFO pHeader;
	m_tree.DeleteAllItems();

	pHeader=m_storage.GetHeader();
	hRoot=m_tree.InsertItem("Root",4,4);
	
	InsertToTree(pHeader,hRoot);

	m_tree.Expand(hRoot,TVE_EXPAND);
	m_tree.SelectItem(hRoot);
}

void CChildView::InsertToTree(PSTORAGE_INFO pInsert,HTREEITEM hInsert){
	HTREEITEM hItem;
	if(hInsert){
		HTREEITEM hDel;
		hItem=m_tree.GetChildItem(hInsert);
		while(hItem){
			hDel=hItem;
			hItem=m_tree.GetNextItem(hItem,TVGN_NEXT);
			m_tree.DeleteItem(hDel);
		}
	}
	while(pInsert){
		if(pInsert->bFolder  && !pInsert->bDeleted){
			if(!hInsert){
				hItem=m_tree.InsertItem(pInsert->szName,0);
			}else{
				hItem=m_tree.InsertItem(pInsert->szName,0,1,hInsert);
			}
			m_tree.SetItemData(hItem,(DWORD_PTR)pInsert);

			if(pInsert->pSub){
				InsertToTree(pInsert->pSub,hItem);
			}
		}
		pInsert=pInsert->pNext;
	}
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	if(!bDown){
		HitTest(point);
	}else{
		SetCursorWE();
		DrawSizeLine(point);
	}
	CWnd::OnMouseMove(nFlags, point);
}

void CChildView::DrawSizeLine(POINT &ptCursor){
	RECT rcClient;
	CDC *pDC;
	CPen pen,*old_pen;

	FixSizeCoordinate(ptCursor);
	GetClientRect(&rcClient);
	pDC=GetDC();

	pen.CreatePen(PS_SOLID,3,RGB(255,255,255));
	old_pen=(CPen*)pDC->SelectObject(&pen);
	pDC->SetROP2(R2_XORPEN);
	if(ptPrevious.x!=0){
		pDC->MoveTo(ptPrevious.x,0);
		pDC->LineTo(ptPrevious.x,rcClient.bottom);
	}

	pDC->MoveTo(ptCursor.x,0);
	pDC->LineTo(ptCursor.x,rcClient.bottom);

	pDC->SelectObject(old_pen);
	pen.DeleteObject();
	ptPrevious.x=ptCursor.x;
	ReleaseDC(pDC);
}

void CChildView::FixSizeCoordinate(POINT &ptCursor){
	RECT rcClient;
	GetClientRect(&rcClient);
	if(ptCursor.x<150 && ptCursor.x!=0){
		ptCursor.x=150;
	}
	if(rcClient.right-250<ptCursor.x){
		ptCursor.x=rcClient.right-250;
	}
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	if(HitTest(point)){
		bDown=TRUE;
		SetCapture();
		ptPrevious.x=ptPrevious.y=0;
	}
	CWnd::OnLButtonDown(nFlags, point);
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	if(bDown){
		bDown=FALSE;
		ReleaseCapture();
		DrawSizeLine(CPoint(0,0));

		FixSizeCoordinate(point);
		m_tree_width=point.x;
		Recalc();
		AfxGetApp()->WriteProfileInt(TREE_SECTION,"tree_width",m_tree_width);
	}
	CWnd::OnLButtonUp(nFlags, point);
}

void CChildView::SetCursorWE(){
	HCURSOR hCursor;
	hCursor=LoadCursor(NULL,(LPCTSTR)IDC_SIZEWE);
	SetCursor(hCursor);
	DestroyCursor(hCursor);
}

BOOL CChildView::HitTest(POINT &ptCursor){
	if(ptCursor.x>=m_tree_width && ptCursor.x<=m_tree_width+4){
		SetCursorWE();
		return TRUE;
	}
	return FALSE;
}

void CChildView::OnTreeSelChange(){
	PSTORAGE_INFO pInfo;
	HTREEITEM hItem;
	hItem=m_tree.GetSelectedItem();
	if(hItem){
		pInfo=(PSTORAGE_INFO)(DWORD_PTR)m_tree.GetItemData(hItem);
		if(pInfo){
			pCurrent=pInfo;
			InsertToList(pInfo->pSub,hItem);
		}else if(m_storage.GetHeader()){
			pCurrent=NULL;
			InsertToList(m_storage.GetHeader(),NULL);
		}
	}
}

void CChildView::OnListSelChange(){
	int iIndex;
	PSTORAGE_INFO pInfo;
	iIndex=m_list.GetSelectionMark();
	if(iIndex!=-1){
		pInfo=(PSTORAGE_INFO)(DWORD_PTR)m_list.GetItemData(iIndex);
		if(pInfo){
			if(pInfo->bFolder){
				m_tree.SelectedItem((DWORD_PTR)pInfo);
			}else{
				////do connect to this host
				CViewer *pView;
				pView=new CViewer;
				pView->SetViewOnly(FALSE);
				pView->Create(IDD_VIEWER,GetDesktopWindow());
				pView->DoConnect(pInfo->pLogin->dwIP,pInfo->pLogin->uPort,pInfo->pLogin->szUserName,pInfo->pLogin->szPassword);
			}
		}else{
			m_tree.SelectItem(hRoot);
		}
	}
}

void CChildView::OnBack(){
	if(pCurrent){
		if(pCurrent->pParent){
			m_tree.SelectedItem((DWORD_PTR)pCurrent->pParent);
		}else{
			m_tree.SelectItem(hRoot);
		}
	}
}

void CChildView::InsertToList(PSTORAGE_INFO pInsert,HTREEITEM hItem){
	PSTORAGE_INFO pTemp;
	int iIndex;
	iIndex=0;

	pTemp=pInsert;
	m_list.DeleteAllItems();

	if(hItem && hItem!=hRoot){
		PSTORAGE_INFO pParent;
		pParent=(PSTORAGE_INFO)m_tree.GetItemData(m_tree.GetParentItem(hItem));
		iIndex=m_list.InsertItem(iIndex,"...",3);
		m_list.SetItemData(iIndex,(DWORD_PTR)pParent);
		iIndex++;
	}

	while(pInsert){		//insert folder
		if(pInsert->bFolder && pInsert->bDeleted ==FALSE){
			iIndex=m_list.InsertItem(iIndex,pInsert->szName,0);
			m_list.SetItemData(iIndex,(DWORD_PTR)pInsert);
		}
		pInsert=pInsert->pNext;
		iIndex++;
	}

	pInsert=pTemp;
	while(pInsert){		//insert computer
		if(!pInsert->bFolder && pInsert->bDeleted ==FALSE){
			iIndex=m_list.InsertItem(iIndex,pInsert->szName,2);
			m_list.SetItemData(iIndex,(DWORD_PTR)pInsert);
		}
		pInsert=pInsert->pNext;
		iIndex++;
	}
}

void CChildView::OnUpdateHeader(PSTORAGE_INFO pInfo,PSTORAGE_INFO pNew){
	HTREEITEM hItem;
	m_storage.UpdateHeader(pInfo,pNew);
	
	hItem=m_tree.FindItemByObj((DWORD_PTR)pInfo);
	if(hItem){
		m_tree.SetItemData(hItem,(DWORD_PTR)pNew);
		m_tree.SetItemText(hItem,pNew->szName );
	}
	OnTreeSelChange();
}

void CChildView::InsertToTreeRoot(PSTORAGE_INFO pItem){
	if(pItem->pParent){
		if(pItem->pParent->pSub ==pItem){
			pItem->pParent->pSub=pItem->pNext;
		}
	}
	if(pItem->pPrev){
		pItem->pPrev->pNext =pItem->pNext;
	}

	if(pItem->pNext){
		pItem->pNext->pPrev =pItem->pPrev;
	}

	if(m_storage.pHeader){
		m_storage.pHeader->pPrev=pItem;
	}

	pItem->pNext =m_storage.pHeader;
	m_storage.pHeader =pItem;
	pItem->pParent =NULL;
	pItem->pPrev =NULL;

	InitializeDirectory();
}

#include <time.h>
void CChildView::OnNewdirectory()
{
	// TODO: ڴ
	char szNew[128];
	HTREEITEM hItem;
	PSTORAGE_INFO pNew;

	srand((unsigned int)time(NULL));
	wsprintf(szNew,"New folder%d",rand()%1000);

	pNew=m_storage.AddItem(szNew,TRUE,pCurrent);
	hItem=m_tree.GetSelectedItem();
	if(hItem){
		hItem=m_tree.InsertItem(szNew,0,1,hItem);
	}else{
		hItem=m_tree.InsertItem(szNew,0,1);
	}
	m_tree.SetItemData(hItem,(DWORD_PTR)pNew);
	m_tree.EnsureVisible(hItem);
	m_tree.SelectItem(hItem);

	m_tree.EditLabel(hItem);
}

void CChildView::ModifyAttribute(PSTORAGE_INFO pInfo){
	PSTORAGE_INFO pNew;
	PLOGIN_INFO pLogin;
	pLogin=pInfo->pLogin;
	pNew=m_storage.UpdateItemText(pInfo,m_host_attr.m_identifier);
	if(pInfo==m_storage.pHeader){
		m_storage.pHeader =pNew;
	}
	strcpy(pLogin->szUserName,m_host_attr.m_username);
	strcpy(pLogin->szPassword,m_host_attr.m_password);
	pLogin->dwIP =m_host_attr.m_hostip;
	pLogin->uPort =(unsigned short)m_host_attr.m_port;
	this->OnTreeSelChange();

}

void CChildView::OnNewhost()
{
	// TODO: ڴ
	PSTORAGE_INFO pNew;
	PLOGIN_INFO pLogin;
	if(m_host_attr.DoModal()==IDOK){
		pNew=m_storage.AddItem(m_host_attr.m_identifier,FALSE,pCurrent);
		pLogin=new LOGIN_INFO;
		pNew->pLogin =pLogin;
		ModifyAttribute(pNew);
	}
}

void CChildView::DoMove(PSTORAGE_INFO pSrc,PSTORAGE_INFO pDst){
	m_storage.UpdateItemPosition(pSrc,pDst);
	m_tree.DeleteRelative((DWORD_PTR)pSrc);
	InsertToTree(pSrc,m_tree.FindItemByObj((DWORD_PTR)pDst));
	m_tree.SelectItem(m_tree.FindItemByObj((DWORD_PTR)pDst));

	OnTreeSelChange();
}

void CChildView::OnRename()
{
	// TODO: ڴ
	if(GetFocus()->m_hWnd==m_tree.m_hWnd){
		if(m_tree.GetSelectedItem()){
			m_tree.EditLabel(m_tree.GetSelectedItem());
		}
	}else{
		m_list.EditLabel(m_list.GetSelectionMark());
	}
}


BOOL CChildView::OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	// TODO: ڴרô/û
	return __super::OnWndMsg(message, wParam, lParam, pResult);
}

void CChildView::OnDelete()
{
	// TODO: ڴ
	PSTORAGE_INFO pInfo;
	HTREEITEM hItem;
	int iItem;
	if(GetFocus()->m_hWnd ==m_tree.m_hWnd){
		hItem=m_tree.GetSelectedItem();
		if(hItem){
			pInfo=(PSTORAGE_INFO)(DWORD_PTR)m_tree.GetItemData(hItem);
			if(pInfo){
				if(AfxMessageBox("Are you sure to delete the item",MB_YESNO)==IDYES){
					pInfo->bDeleted =TRUE;
					m_tree.DeleteItem(hItem);
				}
			}
		}
	}else{
		iItem=m_list.GetSelectionMark();
		if(iItem!=-1){
			if(AfxMessageBox("Are you sure to delete the item",MB_YESNO)==IDYES){
				pInfo=(PSTORAGE_INFO)m_list.GetItemData(iItem);
				pInfo->bDeleted=TRUE;
				m_list.DeleteItem(iItem);
				if(pInfo->bFolder){
					m_tree.SelectedItem((DWORD_PTR)pInfo);
					hItem=m_tree.GetSelectedItem();
					if(hItem){
						m_tree.DeleteItem(hItem);
					}
				}
			}
		}
	}
}

void CChildView::OnAttributes()
{
	// TODO: ڴ
	PSTORAGE_INFO pInfo;
	int iItem;
	iItem=m_list.GetSelectionMark();
	if(iItem!=-1){
		pInfo=(PSTORAGE_INFO)m_list.GetItemData(iItem);
		m_host_attr.m_identifier=pInfo->szName;
		m_host_attr.m_hostip =pInfo->pLogin->dwIP;
		m_host_attr.m_port =pInfo->pLogin->uPort;
		m_host_attr.m_username =pInfo->pLogin->szUserName;
		m_host_attr.m_password =pInfo->pLogin->szPassword;
		if(m_host_attr.DoModal()==IDOK){
			ModifyAttribute(pInfo);
		}
	}
}

void CChildView::OnFullcontrol()
{
	// TODO: ڴ
	int iIndex;
	PSTORAGE_INFO pInfo;
	iIndex=m_list.GetSelectionMark();
	if(iIndex!=-1){
		pInfo=(PSTORAGE_INFO)(DWORD_PTR)m_list.GetItemData(iIndex);
		if(pInfo){
			if(!pInfo->bFolder){
				////do connect to this host
				CViewer *pView;
				pView=new CViewer;
				pView->SetViewOnly(FALSE);
				pView->Create(IDD_VIEWER,GetDesktopWindow());
				pView->DoConnect(pInfo->pLogin->dwIP,pInfo->pLogin->uPort,pInfo->pLogin->szUserName,pInfo->pLogin->szPassword);
			}
		}
	}
}

void CChildView::OnViewonly()
{
	// TODO: ڴ
	int iIndex;
	PSTORAGE_INFO pInfo;
	iIndex=m_list.GetSelectionMark();
	if(iIndex!=-1){
		pInfo=(PSTORAGE_INFO)(DWORD_PTR)m_list.GetItemData(iIndex);
		if(pInfo){
			if(!pInfo->bFolder){
				////do connect to this host
				CViewer *pView;
				pView=new CViewer;
				pView->SetViewOnly(TRUE);
				pView->Create(IDD_VIEWER,GetDesktopWindow());
				pView->DoConnect(pInfo->pLogin->dwIP,pInfo->pLogin->uPort,pInfo->pLogin->szUserName,pInfo->pLogin->szPassword);
			}
		}
	}
}
