#include "StdAfx.h"
#include ".\dragitem.h"
#include "Resource.h"

CDragItem::CDragItem(void)
{
	pDrag=NULL;
}

CDragItem::~CDragItem(void)
{
}

void CDragItem::SetTreeList(CTreeList *pTree,CListComputers *pComputers){
	this->pComputers =pComputers;
	this->pTree =pTree;
}

void CDragItem::BeginDragItem(HWND hWnd,PSTORAGE_INFO pDrag){
	this->pDrag =pDrag;
	SetCapture(hWnd);
}

void CDragItem::DragMove(){
	if(CanDrop()||(bTree && pTree->GetDropRoot() && pDrag->pParent)){
		SetCursor(LoadCursor(AfxGetInstanceHandle(),(LPCSTR)IDC_POINTER_MOVE));
	}else{
		SetCursor(LoadCursor(AfxGetInstanceHandle(),(LPCSTR)IDC_NODROP));
	}
}

void CDragItem::DragEnd(){
	PSTORAGE_INFO pDest;
	ReleaseCapture();

	pDest=CanDrop();
	if(pDest){
		DoMove(pDrag,pDest);
	}else if(bTree && pTree->GetDropRoot() && pDrag->pParent){
		DoMove(pDrag,NULL);
	}
}

PSTORAGE_INFO CDragItem::CanDrop(){
	PSTORAGE_INFO pDest;
	IQueryItem *pQuery;
	POINT ptCursor;
	HWND hPtDest;

	bTree=FALSE;
	pQuery=NULL;
	GetCursorPos(&ptCursor);

	hPtDest=WindowFromPoint(ptCursor);
	if(hPtDest==pTree->m_hWnd){
		pQuery=pTree;
		bTree=TRUE;
	}else if(hPtDest==pComputers->m_hWnd){
		pQuery=pComputers;
	}
	if(pQuery){
		pDest=pQuery->GetHitItemEx();
		if(pDest && !IsSubFolder(pDrag,pDest) && pDrag->pParent !=pDest && pDest->bFolder==TRUE && pDest!=pDrag){
			return pDest;
		}
	}
	return NULL;
}

BOOL CDragItem::IsSubFolder(PSTORAGE_INFO pParent,PSTORAGE_INFO pItem){
	if(pParent->pSub){
		return IsSubFolderEx(pParent->pSub,pItem);
	}
	return FALSE;
}

BOOL CDragItem::IsSubFolderEx(PSTORAGE_INFO pParent,PSTORAGE_INFO pItem){
	while(pParent){
		if(pParent->pSub){
			if(IsSubFolderEx(pParent->pSub,pItem)){
				return TRUE;
			}
		}
		if(pParent==pItem){
			return TRUE;
		}
		pParent=pParent->pNext;
	}
	return FALSE;
}

/*
void CDragItem::DoMove(PSTORAGE_INFO pDest){
	if(pDest){
		CStorageImpl::UpdateItemPosition(pDrag,pDest);
	}else{
		//insert to root
	}
	PSTORAGE_INFO pTemp1;
	PSTORAGE_INFO pTemp2;
	pTemp2=pDrag;
	if(pTemp1){
		CStorageImpl::UpdateItemPosition(pTemp2,pTemp1);
		pTree->SelectItem(GetRootItem());
		DeleteItem(hHitItem);
		((CChildView*)GetParent())->InsertToTree(pTemp2,hDest);
	}else{
		((CChildView*)GetParent())->InsertToTreeRoot(pTemp2);
	}
}*/