#include "Stdafx.h"
#include ".\functionhelper.h"
#include "Resource.h"
#define GLOBAL_INSTANCE GetModuleHandle(NULL)

#define TOOL_HEIGHT		23
#define TOP_OFFSET		2
#define ICON_WIDTH		16
#define ICON_HEIGHT		16

CFunctionHelper::CFunctionHelper(void)
{
	LOGFONT lFont;
	memset((void*)&rcHit,0,sizeof(rcHit));
	memset((void*)&lFont,0,sizeof(lFont));
	lFont.lfCharSet =DEFAULT_CHARSET;
	strcpy(lFont.lfFaceName,"Arial");
	lFont.lfHeight =16;
	hFont=CreateFontIndirect(&lFont);
	lFont.lfUnderline =TRUE;
	hUnderlineFont=CreateFontIndirect(&lFont);
	pHeader=NULL;
}

CFunctionHelper::~CFunctionHelper(void)
{
	Clear();
	DeleteObject(hFont);
	DeleteObject(hUnderlineFont);
}

void CFunctionHelper::SetGray(LONG lCmdID,BOOL bGray){
	PFUNCTION_ICON pItem;
	pItem=pHeader;
	while(pItem){
		if(pItem->lCmdID ==lCmdID){
			pItem->bGray =bGray;
			break;
		}
		pItem=pItem->pNext;
	}
}

void CFunctionHelper::Clear(){
	PFUNCTION_ICON pDel;
	PFUNCTION_ICON pFunc;
	pFunc=pHeader;
	while(pFunc){
		pDel=pFunc;
		pFunc=pFunc->pNext;
		delete pDel;
	}
	pHeader=NULL;
}

void CFunctionHelper::AddFunction(const char *pszCaption,long lIcon,long lCmd){
	PFUNCTION_ICON pFunc;
	pFunc=new FUNCTION_ICON;
	memset((void*)pFunc,0,sizeof(FUNCTION_ICON));
	strcpy(pFunc->szCaption,pszCaption);
	pFunc->lIconIDFromRes =lIcon;
	pFunc->lCmdID =lCmd;

	pFunc->pNext =pHeader;
	pHeader=pFunc;
}

PFUNCTION_ICON CFunctionHelper::HitTest(long xPos){
	PFUNCTION_ICON pFunc;
	pFunc=pHeader;
	while(pFunc){
		if(xPos>=pFunc->lLeft && xPos<=pFunc->lLeft +pFunc->lWidth){
			return pFunc;
		}
		pFunc=pFunc->pNext;
	}
	if(xPos>rcHit.left && xPos<rcHit.right){
		return (PFUNCTION_ICON)0x1;
	}
	return NULL;
}

void CFunctionHelper::DrawFunctionPartOnDC(HDC hDC){
	long lxOffset;
	PFUNCTION_ICON pFunc;
	pFunc=pHeader;
	lxOffset=0;
	while(pFunc){
		pFunc->lLeft =lxOffset;
		lxOffset+=DrawPartOnDC(hDC,pFunc);
		pFunc=pFunc->pNext;
	}
	SIZE szExtent;
	HFONT OldFont;
	const char *pszDownloading="Download development kit";
	SetTextColor(hDC,RGB(0,0,255));

	OldFont=(HFONT)SelectObject(hDC,hUnderlineFont);

	GetTextExtentPoint(hDC,pszDownloading,(int)strlen(pszDownloading),&szExtent);
	rcHit.left =lxOffset+150;
	rcHit.right =szExtent.cx+rcHit.left;
	rcHit.top =0;
	rcHit.bottom =szExtent.cy;
	TextOut(hDC,rcHit.left,TOP_OFFSET,pszDownloading,(int)strlen(pszDownloading));
	SelectObject(hDC,OldFont);
}

long CFunctionHelper::DrawPartOnDC(HDC hDC,PFUNCTION_ICON pObj,COLORREF rgbText){
	HFONT OldFont;
	HDC hTempDC;
	SIZE sizeText;
	HBITMAP hBitmap,OldBitmap;
	hTempDC=CreateCompatibleDC(hDC);
	hBitmap=LoadBitmap(GLOBAL_INSTANCE,(LPCTSTR)IDB_TOOLBAR);
	OldBitmap=(HBITMAP)SelectObject(hTempDC,hBitmap);

	SetBkMode(hDC,TRANSPARENT);
	SetTextColor(hDC,rgbText);

	GetTextExtentPoint(hDC,pObj->szCaption,(int)strlen(pObj->szCaption),&sizeText);
	pObj->lWidth =sizeText.cx+ICON_WIDTH;	
//////////////////////////////////////////////Do Draw
	if(pObj->bSelected){
		DrawSelectedPartOnDC(hDC,pObj);
	}
	BitBlt(hDC,pObj->lLeft,TOP_OFFSET,ICON_WIDTH,ICON_HEIGHT,hTempDC,pObj->lIconIDFromRes*16,0,SRCAND);
	if(pObj->bGray){
		SetTextColor(hDC,RGB(128,128,128));
	}else{
		SetTextColor(hDC,rgbText);
	}

	OldFont=(HFONT)SelectObject(hDC,hFont);

	TextOut(hDC,pObj->lLeft +ICON_WIDTH+1,TOP_OFFSET,pObj->szCaption,(int)strlen(pObj->szCaption));

	SelectObject(hDC,OldFont);

	SelectObject(hTempDC,OldBitmap);
	DeleteObject(hBitmap);
	DeleteDC(hTempDC);

	return sizeText.cx+ICON_WIDTH+8;
}

void CFunctionHelper::DrawSelectedPartOnDC(HDC hDC,PFUNCTION_ICON pObj){
	////////////////////////////////////////////////////////////////////
	HPEN hPen,OldPen;
	HBRUSH hBrush,OldBrush;
	hPen=CreatePen(PS_SOLID,1,RGB(49,106,197));
	hBrush=CreateSolidBrush(RGB(225,230,232));
	OldPen=(HPEN)SelectObject(hDC,hPen);
	OldBrush=(HBRUSH)SelectObject(hDC,hBrush);

	Rectangle(hDC,pObj->lLeft-2,TOP_OFFSET,pObj->lLeft +pObj->lWidth+2,TOOL_HEIGHT);

	SelectObject(hDC,OldPen);
	SelectObject(hDC,OldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
}

PFUNCTION_ICON CFunctionHelper::OnMouseMove(HDC hDC,long xPosition){
	static PFUNCTION_ICON pPrev=NULL;
	PFUNCTION_ICON pFunc;

	pFunc=HitTest(xPosition);
	if(pFunc==(PFUNCTION_ICON)0x1){
		HCURSOR hCursor;
		hCursor=LoadCursor(NULL,IDC_HAND);
		SetCursor(hCursor);
	}else{
		if(pFunc && pFunc!=pPrev){
			DrawPartOnDC (hDC,pFunc,RGB(104,123,204));
			if(pPrev){
				DrawPartOnDC(hDC,pPrev);
			}
			pPrev=pFunc;
		}else if(!pFunc){
			if(pPrev){
				DrawPartOnDC(hDC,pPrev);
			}
			pPrev=NULL;
		}
	}
	return pFunc;
}