#pragma once

#define MY_FOLDER_IDENTIFIER 0x3437
#include <pshpack1.h>

typedef struct{
	DWORD dwIP;
	unsigned short uPort;
	char szUserName[32];
	char szPassword[32];
}LOGIN_INFO,*PLOGIN_INFO;

struct STORAGE_INFO{
    USHORT			cb;
	USHORT			identifier;
	BOOL			bFolder;
	BOOL			bDeleted;

	STORAGE_INFO	*pParent;	//parent object
	STORAGE_INFO	*pSub;		//sub objects

	STORAGE_INFO	*pPrev;		//prev object
	STORAGE_INFO	*pNext;		//next object
	PLOGIN_INFO		pLogin;
	char			szName[1];
};

#include <poppack.h>

typedef STORAGE_INFO *PSTORAGE_INFO;

#include "publicIf.h"

class CStorageImpl
{
public:
	CStorageImpl(void);
	~CStorageImpl(void);
public:
	static PSTORAGE_INFO UpdateItemText(PSTORAGE_INFO pInfo,const char *pszText);
	void UpdateItemPosition(PSTORAGE_INFO pInfo,PSTORAGE_INFO pNewParent);
	void DeleteRelation(PSTORAGE_INFO pInfo);
	void SetParent(PSTORAGE_INFO pInfo,PSTORAGE_INFO pParent);
public:
	BOOL Save(wchar_t *pszFile);
	void Load(wchar_t *pszFile);
	void InitializeForForstRun();
	void ClearItem(PSTORAGE_INFO pSub);
	void UpdateHeader(PSTORAGE_INFO pInfo,PSTORAGE_INFO pNew);

	PSTORAGE_INFO AddItem(const char *pszName,BOOL bFolder,PSTORAGE_INFO pParent);
	PSTORAGE_INFO GetHeader();
private:
	PSTORAGE_INFO DoReadInfo(IStorage*,PSTORAGE_INFO pParent);
	void DoWriteInfo(IStorage*,PSTORAGE_INFO pStore);
private:
	void InsertToRoot(PSTORAGE_INFO pNew);
	void InsertToFirst(PSTORAGE_INFO pNew,PSTORAGE_INFO pPrev);
	void ClearAllItems();
	void ClearSub(PSTORAGE_INFO pSub);
	void SkipCurrentElement(PSTORAGE_INFO pItem);
	void DeleteItem(PSTORAGE_INFO pDel);
public:
	PSTORAGE_INFO pHeader;
};
