// TreeList.cpp : ʵļ
//

#include "stdafx.h"
#include "resource.h"
#include "FullRemoteDisplayV.h"
#include "TreeList.h"


// CTreeList

IMPLEMENT_DYNAMIC(CTreeList, CTreeCtrl)
CTreeList::CTreeList()
{
	hHitItem=NULL;
	bDrag=FALSE;
}

CTreeList::~CTreeList()
{
}


BEGIN_MESSAGE_MAP(CTreeList, CTreeCtrl)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnTvnSelchanged)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, OnTvnEndlabeledit)
	ON_NOTIFY_REFLECT(TVN_BEGINLABELEDIT, OnTvnBeginlabeledit)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()



#include "ChildView.h"
#include ".\treelist.h"

void CTreeList::OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	((CChildView*)GetParent())->OnTreeSelChange();

	*pResult = 0;
}

void CTreeList::SelectedItem(DWORD_PTR dwData){
	HTREEITEM hItem;
	hItem=FindItemByObj(dwData);
	if(hItem){
		EnsureVisible(hItem);
		SelectItem(hItem);
	}
}

void CTreeList::DeleteRelative(DWORD_PTR dwData){
	HTREEITEM hItem;
	hItem=FindItemByObj(dwData);
	if(hItem){
		DeleteItem(hItem);
	}
}

HTREEITEM CTreeList::FindItemByObjEx(HTREEITEM hItem,DWORD_PTR dwData){
	HTREEITEM hSearch;
	while(hItem){
		if(ItemHasChildren(hItem)){
			if(hSearch=FindItemByObjEx(GetNextItem(hItem,TVGN_CHILD),dwData)){
				return hSearch;
			}
		}
		if(GetItemData(hItem)==dwData){
			return hItem;
		}
		hItem=GetNextItem(hItem,TVGN_NEXT);
	}
	return NULL;
}

HTREEITEM CTreeList::FindItemByObj(DWORD_PTR dwData){
	HTREEITEM hSearch;
	HTREEITEM hItem;
	hItem=GetRootItem();
	while(hItem){
		if(hSearch=FindItemByObjEx(hItem,dwData)){
			return hSearch;
		}
		hItem=GetNextItem(hItem,TVGN_NEXT);
	}
	return NULL;
}

void CTreeList::OnTvnEndlabeledit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	HTREEITEM hItem;
	hItem=GetSelectedItem();
	if(pTVDispInfo->item.pszText && strlen(pTVDispInfo->item.pszText)){
		UpdateItem(hItem,(PSTORAGE_INFO)GetItemData(hItem),pTVDispInfo->item.pszText);
		SetItemText(hItem,pTVDispInfo->item.pszText);
	}
	
	*pResult = 0;
}

void CTreeList::UpdateItem(HTREEITEM hItem,PSTORAGE_INFO pInfo,const char *pszText){
	PSTORAGE_INFO pNew;
	pNew=CStorageImpl::UpdateItemText(pInfo,pszText);
	SetItemData(hItem,(DWORD_PTR)pNew);
	((CChildView*)GetParent())->OnUpdateHeader(pInfo,pNew);
}

void CTreeList::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	hHitItem=GetHitItem();
	ptPress=point;
	CTreeCtrl::OnLButtonDown(nFlags, point);
}

void CTreeList::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	if(bDrag){
		((CChildView*)GetParent())->DragEnd();
	}
	bDrag=FALSE;
	hHitItem=NULL;

	CTreeCtrl::OnLButtonUp(nFlags, point);
}

void CTreeList::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	PSTORAGE_INFO pInfo;
	if(!bDrag && GetKeyState(VK_LBUTTON)&0x80){
		if(abs(ptPress.x-point.x)>5||abs(ptPress.y-point.y)>5){
			if(hHitItem){
				pInfo=(PSTORAGE_INFO)GetItemData(hHitItem);
				if(pInfo){
					((CChildView*)GetParent())->BeginDragItem(m_hWnd,pInfo);
					SelectItem(hHitItem);
					bDrag=TRUE;
				}
			}
		}
	}
	if(bDrag){
		((CChildView*)GetParent())->DragMove();
	}
	CTreeCtrl::OnMouseMove(nFlags, point);
}


HTREEITEM CTreeList::GetHitItem(){
	CPoint ptHit;
	TVHITTESTINFO hitInfo;
	GetCursorPos(&ptHit);
	ScreenToClient(&ptHit);
	memset((void*)&hitInfo,0,sizeof(hitInfo));
	hitInfo.pt.x=ptHit.x;
	hitInfo.pt.y=ptHit.y;
	hitInfo.hItem =NULL;

	HitTest(&hitInfo);
	if(hitInfo.flags &TVHT_ONITEM){
		return hitInfo.hItem;
	}
	return NULL;
}
void CTreeList::OnTvnBeginlabeledit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ
	if(this->GetSelectedItem()==GetRootItem()){
		*pResult = 1;
	}else{
		*pResult = 0;
	}
}

PSTORAGE_INFO CTreeList::GetHitItemEx(){
	HTREEITEM hItem;
	hItem=GetHitItem();

	bDropToRoot=FALSE;
	if(hItem){
		if(hItem==GetRootItem()){
			bDropToRoot=TRUE;
		}
		return (PSTORAGE_INFO)GetItemData(hItem);
	}
	return NULL;
}

BOOL CTreeList::GetDropRoot(){
	return bDropToRoot;
}


void CTreeList::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	HMENU hMenu,hSubMenu;
	POINT ptCursor;

	hLastOP=GetHitItem();
	if(hLastOP){
		SelectItem(hLastOP);
		hMenu=LoadMenu(AfxGetInstanceHandle(),(LPCTSTR)IDR_POPUP);
		hSubMenu=GetSubMenu(hMenu,0);
		if(hLastOP==GetRootItem()){
			EnableMenuItem(hSubMenu,ID_RENAME,MF_GRAYED|MF_BYCOMMAND);
			EnableMenuItem(hSubMenu,ID_DELETE,MF_GRAYED|MF_BYCOMMAND);
		}
		GetCursorPos(&ptCursor);
		SetFocus();
		TrackPopupMenu(hSubMenu,TPM_LEFTALIGN,ptCursor.x,ptCursor.y,NULL,this->GetParent()->m_hWnd,NULL);
		DestroyMenu(hMenu);
	}
}

void CTreeList::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: ڴϢ/Ĭֵ
	if(nChar==VK_DELETE){
		GetParent()->SendMessage(WM_COMMAND,ID_DELETE);
	}
	__super::OnKeyDown(nChar, nRepCnt, nFlags);
}
