#pragma once

#include "StorageImpl.h"
// CTreeList
__interface ITreeEvent{
	virtual void OnTreeSelChange();
	virtual void OnUpdateHeader(PSTORAGE_INFO,PSTORAGE_INFO);
};


class CTreeList : public CTreeCtrl,public IQueryItem
{
	DECLARE_DYNAMIC(CTreeList)

public:
	CTreeList();
	virtual ~CTreeList();

protected:
	DECLARE_MESSAGE_MAP()
private:
	void DoMove(HTREEITEM hItem);

	HTREEITEM FindItemByObjEx(HTREEITEM hItem,DWORD_PTR dwData);
	void UpdateItem(HTREEITEM,PSTORAGE_INFO pInfo,const char *pszText);
	HTREEITEM GetHitItem();
public:
	PSTORAGE_INFO GetHitItemEx();
	BOOL GetDropRoot();
	void DeleteRelative(DWORD_PTR dwData);
private:
	HTREEITEM hHitItem;
	HTREEITEM hLastOP;
	CPoint ptPress;
	BOOL bDrag;
	BOOL bDropToRoot;
public:
	void SelectedItem(DWORD_PTR dwData);
	HTREEITEM FindItemByObj(DWORD_PTR dwData);
public:
	afx_msg void OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnEndlabeledit(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTvnBeginlabeledit(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
};


