// RClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RClient.h"
#include "RClientDlg.h"
#include ".\rclientdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRClientDlg dialog



CRClientDlg::CRClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRClientDlg::IDD, pParent)
{
	pView=NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CRClientDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BREAK, OnBnClickedBreak)
	ON_BN_CLICKED(IDC_STRETCH, OnBnClickedStretch)
END_MESSAGE_MAP()


// CRClientDlg message handlers

BOOL CRClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	IUnknown *pUnk;
	pUnk=GetDlgItem(IDC_RVIEWER1)->GetControlUnknown();
	if(pUnk){
		pUnk->QueryInterface(&pView);
	}

	SetDlgItemText(IDC_IPADDRESS,"127.0.0.1");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRClientDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	CString strIP;
	if(pView){
		GetDlgItemText(IDC_IPADDRESS,strIP);
		pView->RefreshRegionNotify =VARIANT_TRUE;
		pView->Operable =VARIANT_TRUE;
		if(pView->Connect((const char*)strIP,6333,"")==VARIANT_TRUE){
			GetDlgItem(IDOK)->EnableWindow(FALSE);
		}
	}
}

void CRClientDlg::OnDestroy()
{
	CDialog::OnDestroy();
	if(pView){
		pView->Release();
	}
	// TODO: ڴ˴Ϣ
}

void CRClientDlg::OnBnClickedBreak()
{
	// TODO: ڴӿؼ֪ͨ
	GetDlgItem(IDOK)->EnableWindow();
	if(pView){
		pView->Break();
	}
}

void CRClientDlg::OnBnClickedStretch()
{
	// TODO: ڴӿؼ֪ͨ
	if(pView){
		if(pView->Stretch==VARIANT_TRUE){
			pView->Stretch =VARIANT_FALSE;
		}else{
			pView->Stretch =VARIANT_TRUE;
		}
	}
}
BEGIN_EVENTSINK_MAP(CRClientDlg, CDialog)
	ON_EVENT(CRClientDlg, IDC_RVIEWER1, 5, OnRefreshRegionRviewer1, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
END_EVENTSINK_MAP()

void CRClientDlg::OnRefreshRegionRviewer1(long xPosition, long yPosition, long lWidth, long lHeight)
{
	// TODO: ڴ˴Ϣ
	CDC *pDC;
	SIZE sz;
	LPDISPATCH pDisp;
	IPictureDisp *pPicture;
	IPicture *pDraw;
	OLE_XSIZE_HIMETRIC xsize;
	OLE_YSIZE_HIMETRIC ysize;
	RECT rcDraw;
	pDisp=pView->GetPicture(xPosition,yPosition,lWidth,lHeight);
	if(pDisp){
		if(pDisp->QueryInterface(&pPicture)==S_OK){
			if(pPicture->QueryInterface(&pDraw)==S_OK){
				pDC=GetDC();
				pDraw->get_Width(&xsize);
				pDraw->get_Height(&ysize);

				rcDraw.left =rcDraw.top =0;
				rcDraw.right =xsize;
				rcDraw.bottom =ysize;

				sz.cx=xsize;
				sz.cy=ysize;

				HBITMAP hBmp;
				BITMAP bm;
				hBmp=NULL;
				pDraw->get_Handle((OLE_HANDLE*)&hBmp);
				if(hBmp){
					GetObject(hBmp,sizeof(bm),(LPVOID)&bm);
				}

				pDC->HIMETRICtoDP(&sz);

				pDraw->Render(pDC->m_hDC,0,0,sz.cx,sz.cy,
					0,ysize,xsize,-ysize,&rcDraw);

				pDraw->Release();
				ReleaseDC(pDC);
			}
			pPicture->Release();
		}
		pDisp->Release();
	}
}
