// RServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RServer.h"
#include "RServerDlg.h"
#include ".\rserverdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRServerDlg dialog



CRServerDlg::CRServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRServerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CLIENTS, clients);
}

BEGIN_MESSAGE_MAP(CRServerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDSTOPLISTENING, OnBnClickedStoplistening)
END_MESSAGE_MAP()


// CRServerDlg message handlers

BOOL CRServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	IUnknown *pUnk;
	pUnk=GetDlgItem(IDC_RSERVER1)->GetControlUnknown();
	if(pUnk){
		pUnk->QueryInterface(&pServer);
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRServerDlg::OnBnClickedOk()
{
	if(pServer){
		if(pServer->StartListening(6333)==VARIANT_TRUE){
			GetDlgItem(IDOK)->EnableWindow(FALSE);
			GetDlgItem(IDSTOPLISTENING)->EnableWindow();
		}
	}
}

void CRServerDlg::OnDestroy()
{
	CDialog::OnDestroy();
	if(pServer){
		pServer->StopListening();
		pServer->Release();
	}
	// TODO: ڴ˴Ϣ
}

void CRServerDlg::OnBnClickedStoplistening()
{
	// TODO: ڴӿؼ֪ͨ
	if(pServer){
		pServer->StopListening();
		GetDlgItem(IDOK)->EnableWindow(TRUE);
		GetDlgItem(IDSTOPLISTENING)->EnableWindow(FALSE);
	}
}

void CRServerDlg::GetClients(LONG lClientID){
	long ifor;
	char szBuffer[128];
	IClients *pClients;
	IClient *pClient;
	clients.ResetContent();

	pServer->get_Clients(&pClients);
	if(pClients){
		pClients->Update();
		for(ifor=0;ifor<pClients->Count;ifor++){
			pClients->get_Item(ifor,&pClient);
			if(pClient){
				if(lClientID!=pClient->ClientID){
					wsprintf(szBuffer,"%s:%d",(char*)pClient->StringIPAddress,pClient->Port);
					clients.AddString(szBuffer);
				}
				pClient->Release();
			}
		}
		pClients->Release();
	}
}


BEGIN_EVENTSINK_MAP(CRServerDlg, CDialog)
	ON_EVENT(CRServerDlg, IDC_RSERVER1, 1, OnConnectedRserver1, VTS_I4)
	ON_EVENT(CRServerDlg, IDC_RSERVER1, 3, OnBreakRserver1, VTS_I4)
END_EVENTSINK_MAP()

void CRServerDlg::OnConnectedRserver1(long lClientID)
{
	// TODO: ڴ˴Ϣ
	IClient *pClient;
	pServer->raw_GetClient(lClientID,&pClient);
	if(pClient){
		pClient->put_Operable(VARIANT_TRUE);
		pClient->Release();
	}
	GetClients(0);
}

void CRServerDlg::OnBreakRserver1(long lClientID)
{
	// TODO: ڴ˴Ϣ
	GetClients(lClientID);
}
